Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.cpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.cpp	(revision 2011)
@@ -1154,11 +42,11 @@
 CTransformFilter* CGenericAlgorithmTransformation::createTransformFilter(CGarbageCollector& gc, CGridAlgorithm* algo, bool detectMissingValues, double defaultValue)
 {
-  return new CTransformFilter(gc, algo, detectMissingValues, defaultValue) ;
+  return new CTransformFilter(gc, 1, algo, detectMissingValues, defaultValue) ;
 }
 
-void CGenericAlgorithmTransformation::apply(int dimBefore, int dimAfter, const CArray<double,1>& dataIn, CArray<double,1>& dataOut)
+vector<string> CGenericAlgorithmTransformation::getAuxFieldId(void) 
 {
-  // tranform into pure virtual funtion later
-  abort() ;
+  return vector<string>() ;
 }
+
 }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/generic_algorithm_transformation.hpp	(revision 2011)
@@ -34,160 +34,19 @@
 class CGenericAlgorithmTransformation
 {
-public:
-  enum AlgoTransType {
-    ELEMENT_GENERATION = 0,
-    ELEMENT_MODIFICATION_WITHOUT_DATA = 1,
-    ELEMENT_MODIFICATION_WITH_DATA = 2,
-    ELEMENT_NO_MODIFICATION_WITH_DATA = 3,
-    ELEMENT_NO_MODIFICATION_WITHOUT_DATA = 4
-  } ;
-
-public:
-  // Mapping between global index map of DESTINATION and its local index with pair of global index of SOURCE and weights
-  typedef std::unordered_map<int, std::unordered_map<size_t, std::vector<std::pair<size_t,double> > > > SourceDestinationIndexMap;
-
-protected:
-  typedef std::unordered_map<size_t,int> GlobalLocalMap;
-protected:
-  typedef std::unordered_map<int, std::vector<int> > TransformationIndexMap;
-  typedef std::unordered_map<int, std::vector<double> > TransformationWeightMap;
-  typedef std::unordered_map<int, std::vector<int> > TransformationPositionMap;
-
-public:
-  //CGenericAlgorithmTransformation();
-  CGenericAlgorithmTransformation(bool isSource);
-
-  virtual ~CGenericAlgorithmTransformation() {}
-
-  bool isDistributedTransformation(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst) ;
-
-  void computeGlobalSourceIndex(int elementPositionInGrid,
-                               CGrid* gridSrc,
-                               CGrid* gridDst,
-                               SourceDestinationIndexMap& globaIndexWeightFromSrcToDst);
-
-    /*!
-    Apply a operation on local data.
-    \param [in] localIndex vector contains local index of local data output and the corresponding weight
-    \param [in] dataInput Pointer to the first element of data input array (in form of buffer)
-    \param [in/out] dataOut Array contains local data
-    \param [in/out] flagInitial vector of boolean to mark the local index already initialized. True means there is a need for initalization
-    \param [in] ignoreMissingValue don't count missing value in operation if this flag is true
-    \param [in] firstPass indicate if it is the first time the apply funtion is called for a same transformation, in order to make a clean initialization 
-  */
-  virtual void apply(const std::vector<std::pair<int,double> >& localIndex,
-                     const double* dataInput,
-                     CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,                     
-                     bool ignoreMissingValue, bool firstPass);
-
-  /*!
-   * Update whole dataOut (on necessary).
-   * (Example:  Impose a weight, whose value is only known after being applied an operation, on dataOut)
-   * \param [in/out] dataOut dataOut
-   */
-  virtual void updateData(CArray<double,1>& dataOut);
-
-  std::vector<StdString> getIdAuxInputs();
-  AlgoTransType type();
-  /*!
-  Compute global index mapping from one element of destination grid to the corresponding element of source grid
-  */
-  void computeIndexSourceMapping(const std::vector<CArray<double,1>* >& dataAuxInputs = std::vector<CArray<double,1>* >());
-  void computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
-                                                  vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, int& nbLocalIndexOnGridDest);
-  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst,
-                                    int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc,
-                                    int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
-                                    vector<int>& localSrc, vector<int>& localDst, vector<double>& weight) ;
-
-protected:
-  virtual void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >&) {};
-
-  /*!
-  Compute proc which contains global index of an element
-    \param[in] globalElementIndex demanding global index of an element of source grid
-    \param[in] elementType type of source element, 2: domain, 1: axis and 0: scalar
-    \param[out] globalElementIndexOnProc Proc contains the demanding global index
-  */
-  virtual void computeExchangeGlobalIndex(const CArray<size_t,1>& globalElementIndex,
-                                          int elementType,
-                                          CClientClientDHTInt::Index2VectorInfoTypeMap& globalElementIndexOnProc){};
-
-protected:
-  void computeGlobalGridIndexMapping(int elementPositionInGrid,
-                                     const std::vector<int>& srcRank,
-                                     std::unordered_map<int, std::vector<std::pair<int,double> > >& src2DstMap,
-                                     CGrid* gridDst,
-                                     CGrid* gridSrc,
-                                     std::vector<std::unordered_map<int,std::vector<size_t> > >& globalElementIndexOnProc,
-                                     SourceDestinationIndexMap& globaIndexWeightFromSrcToDst);
-
-  void computeExchangeDomainIndex(CDomain* domainDst,
-                                  CDomain* domainSrc,
-                                  CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                  std::unordered_map<int,std::vector<size_t> >& globalDomainIndexOnProc);
-
-  void computeExchangeAxisIndex(CAxis* axisDst,
-                                CAxis* axisSrc,
-                                CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                std::unordered_map<int,std::vector<size_t> >& globalAxisIndexOnProc);
-
-  void computeExchangeScalarIndex(CScalar* scalarDst,
-                                  CScalar* scalarSrc,
-                                  CArray<size_t,1>& destGlobalIndexPositionInGrid,
-                                  std::unordered_map<int,std::vector<size_t> >& globalScalarIndexOnProc);
-
-  void computePositionElements(CGrid* dst, CGrid* src);
-
-protected:
-  //! indicate if the transformation is performed on a distributed element
-  bool isDistributed_ ;
-  //! indicate if the method  isDistributedTransformation has been called before
-  bool isDistributedComputed_ ;
-  
-  //! Map between global index of destination element and source element
-  std::vector<TransformationIndexMap> transformationMapping_;
-  //! Weight corresponding of source to destination
-  std::vector<TransformationWeightMap> transformationWeight_;
-  //! Map of global index of destination element and corresponding global index of other elements in the same grid
-  //! By default, one index of an element corresponds to all index of remaining element in the grid. So it's empty
-  std::vector<TransformationPositionMap> transformationPosition_;
-
-  //! Id of auxillary inputs which helps doing transformation dynamically
-  std::vector<StdString> idAuxInputs_;
-  AlgoTransType type_;
-
-  std::set<StdSize> indexElementSrc_;
-
-  std::vector<std::unordered_map<int,std::vector<size_t> > > globalElementIndexOnProc_;
-
-  std::vector<int> procContainSrcElementIdx_;  // List of processes containing source index of transformed elements
-//  std::set<int> procOfNonTransformedElements_; // Processes contain the source index of non-transformed elements
-  std::set<int> commonProc_;
-  std::vector< set<int> > procElementList_ ; // List of processes containing source index of elements
-
-  CClientClientDHTInt::Index2VectorInfoTypeMap globalIndexOfTransformedElementOnProc_;
-  
-  bool computedProcSrcNonTransformedElement_; // Flag to indicate whether we computed proc containing non transformed elements
-
-  std::map<int, int> elementPositionInGridSrc2AxisPosition_, elementPositionInGridSrc2DomainPosition_, elementPositionInGridSrc2ScalarPosition_;
-  std::map<int, int> elementPositionInGridDst2AxisPosition_, elementPositionInGridDst2DomainPosition_, elementPositionInGridDst2ScalarPosition_;
-
-  bool eliminateRedondantSrc_ ; // flag to indicate if the transformation must select only one global source point for all proc.
-                               // In this case it will choose preferentially the current process 
-  bool isSource_ ; //flag to indicate that the algorithm is a source algorithm, that mean the grid is modified or generated but 
-                   // no fluxes are tranformed
-  
-// new methods for new algorithm
-
   public : 
-  
+    CGenericAlgorithmTransformation(bool isSource) ;
     virtual CGridAlgorithm* createGridAlgorithm(CGrid* gridSrc, CGrid* newGrid, int pos) ;
     virtual CTransformFilter* createTransformFilter(CGarbageCollector& gc, CGridAlgorithm* algo, bool detectMissingValues, double defaultValue) ;
-    virtual void apply(int dimBefore, int dimAfter, const CArray<double,1>& dataIn, CArray<double,1>& dataOut); // transform into pure virtual function later
+    virtual void apply(int dimBefore, int dimAfter, const CArray<double,1>& dataIn, CArray<double,1>& dataOut) { abort() ;} //=0
+    virtual void apply(int dimBefore, int dimAfter, const CArray<double,1>& dataIn, const vector<CArray<double,1>>& auxData, CArray<double,1>& dataOut) { abort() ;} //=0
+    
+    virtual vector<string> getAuxFieldId(void) ;
   protected :
+    typedef std::unordered_map<int, std::vector<int> > TransformationIndexMap;
+    typedef std::unordered_map<int, std::vector<double> > TransformationWeightMap;
+ 
+    CLocalElement* recvElement_=nullptr ;
+    bool isSource_ ;
 
-    CLocalElement* recvElement_=nullptr ;
   public:
     CLocalElement* getRecvElement(void) { return recvElement_ ;}
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm.hpp	(revision 2011)
@@ -24,5 +24,6 @@
     CGridAlgorithm(CGenericAlgorithmTransformation* algorithm) : algorithm_(algorithm)  {} ;
     virtual ~CGridAlgorithm() {} ;
-    virtual void apply(const CArray<double,1>& dataIn, CArray<double,1>& dataOut)=0 ;
+    virtual void apply(const CArray<double,1>& dataIn, CArray<double,1>& dataOut) { abort(); } //=0
+    virtual void apply(const CArray<double,1>& dataIn, const vector<CArray<double,1>>& auxData, CArray<double,1>& dataOut) { abort(); } //=0
     virtual CTransformFilter* createTransformFilter(CGarbageCollector& gc, bool detectMissingValues, double defaultValue) ;
    
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.cpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.cpp	(revision 2011)
@@ -58,5 +58,15 @@
   }
 
-  
+  void CGridAlgorithmGeneric::apply(const CArray<double,1>& dataIn, const vector<CArray<double,1>>& auxData, CArray<double,1>& dataOut)
+  {
+    CArray<double,1> dataOutTmp ;
+    vector<CArray<double,1>> auxDataOutTmp(auxData.size()) ;
+
+    gridTransformConnector_->transfer(dataIn, dataOutTmp) ;
+    for (int i=0; i<auxData.size();i++)  gridTransformConnector_->transfer(auxData[i], auxDataOutTmp[i]) ;
+
+    algorithm_->apply(dimBefore_, dimAfter_, dataOutTmp, auxDataOutTmp, dataOut) ;
+  }
+ 
 
 }
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/grid_algorithm_generic.hpp	(revision 2011)
@@ -28,5 +28,6 @@
     void computeAlgorithm(void) ;
     virtual void apply(const CArray<double,1>& dataIn, CArray<double,1>& dataOut) ;
- 
+    virtual void apply(const CArray<double,1>& dataIn, const vector<CArray<double,1>>& auxData, CArray<double,1>& dataOut) ;
+    
   protected:
     CGridTransformConnector* gridTransformConnector_=nullptr ;
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_extract_axis.hpp	(revision 2011)
@@ -37,5 +37,5 @@
   int pos_;
 
-private:
+public:
   static CGenericAlgorithmTransformation* create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
                                                 CTransformation<CScalar>* transformation,
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_axis.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_axis.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_axis.hpp	(revision 2011)
@@ -34,6 +34,6 @@
   static bool registerTrans();
 
-private:
 
+public:
   static CGenericAlgorithmTransformation* create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
                                                 CTransformation<CScalar>* transformation,
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_domain.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_domain.hpp	(revision 2011)
@@ -36,6 +36,6 @@
   CDomain* domainSrc_ ;
 
-private:
 
+public:
   static CGenericAlgorithmTransformation* create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
                                                 CTransformation<CScalar>* transformation,
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.cpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.cpp	(revision 2011)
@@ -44,5 +44,5 @@
 
 CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(bool isSource, CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)
- : CScalarAlgorithmTransformation(isSource, scalarDestination, scalarSource), reduction_(0)
+ : CAlgorithmTransformationReduce(isSource)
 TRY
 {
@@ -57,14 +57,14 @@
   {
     case CReduceScalarToScalar::operation_attr::sum:
-      op = "sum";
+      operator_ = EReduction::sum;
       break;
     case CReduceScalarToScalar::operation_attr::min:
-      op = "min";
+      operator_ = EReduction::min;
       break;
     case CReduceScalarToScalar::operation_attr::max:
-      op = "max";
+      operator_ = EReduction::max;
       break;
     case CReduceScalarToScalar::operation_attr::average:
-      op = "average";
+      operator_ = EReduction::average;
       break;
     default:
@@ -75,27 +75,8 @@
 
   }
-  
-  if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
-    ERROR("CScalarAlgorithmReduceScalar::CScalarAlgorithmReduceScalar(CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo)",
-       << "Operation '" << op << "' not found. Please make sure to use a supported one"
-       << "Scalar source " <<scalarSource->getId() << std::endl
-       << "Scalar destination " << scalarDestination->getId());
+  transformationMapping_[0].push_back(0) ;
 
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
-}
-CATCH
-
-void CScalarAlgorithmReduceScalar::apply(const std::vector<std::pair<int,double> >& localIndex, const double* dataInput, CArray<double,1>& dataOut,
-                                         std::vector<bool>& flagInitial, bool ignoreMissingValue, bool firstPass)
-TRY
-{
-  reduction_->apply(localIndex, dataInput, dataOut, flagInitial, ignoreMissingValue, firstPass);
-}
-CATCH
-
-void CScalarAlgorithmReduceScalar::updateData(CArray<double,1>& dataOut)
-TRY
-{
-  reduction_->updateData(dataOut);
+  scalarDestination->checkAttributes() ;
+  this->computeAlgorithm(scalarSource->getLocalView(CElementView::WORKFLOW), scalarDestination->getLocalView(CElementView::WORKFLOW)) ; 
 }
 CATCH
@@ -104,22 +85,7 @@
 TRY
 {
-  if (0 != reduction_) delete reduction_;
 }
 CATCH
 
-void CScalarAlgorithmReduceScalar::computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs)
-TRY
-{
-  this->transformationMapping_.resize(1);
-  this->transformationWeight_.resize(1);
-
-  TransformationIndexMap& transMap = this->transformationMapping_[0];
-  TransformationWeightMap& transWeight = this->transformationWeight_[0];
-
-  transMap[0].push_back(0);
-  transWeight[0].push_back(1.0);
 
 }
-CATCH
-
-}
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/scalar_algorithm/scalar_algorithm_reduce_scalar.hpp	(revision 2011)
@@ -6,5 +6,5 @@
 #define __XIOS_SCALAR_ALGORITHM_REDUCE_SCALAR_HPP__
 
-#include "scalar_algorithm_transformation.hpp"
+#include "algorithm_transformation_reduce.hpp"
 #include "transformation.hpp"
 
@@ -19,28 +19,16 @@
   Reducing an scalar to a scalar
 */
-class CScalarAlgorithmReduceScalar : public CScalarAlgorithmTransformation
+class CScalarAlgorithmReduceScalar : public CAlgorithmTransformationReduce
 {
 public:
   CScalarAlgorithmReduceScalar(bool isSource, CScalar* scalarDestination, CScalar* scalarSource, CReduceScalarToScalar* algo);
 
-  virtual void apply(const std::vector<std::pair<int,double> >& localIndex,
-                     const double* dataInput,
-                     CArray<double,1>& dataOut,
-                     std::vector<bool>& flagInitial,
-                     bool ignoreMissingValue, bool firstPass);
-
-  virtual void updateData(CArray<double,1>& dataOut);
-  
   virtual ~CScalarAlgorithmReduceScalar();
 
   static bool registerTrans();
 protected:
-  void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
+  
 
-protected:
-  CReductionAlgorithm* reduction_;
-
-private:
-
+public:
   static CGenericAlgorithmTransformation* create(bool isSource, CGrid* gridDst, CGrid* gridSrc,
                                                 CTransformation<CScalar>* transformation,
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/transformation.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/transformation.hpp	(revision 2010)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/transformation/transformation.hpp	(revision 2011)
@@ -13,4 +13,7 @@
     This class describes inverse_axis in xml file.
   */
+  class CGenericAlgorithmTransformation;
+   class CGrid;
+
   template<typename T>
   class CTransformation
@@ -36,4 +39,14 @@
       virtual const string& getName(void) { ERROR("string Transformation<T>::getId())",<< "unimplemented virtual function for child"); } ;
       virtual const string& getDefName(void) { ERROR("string Transformation<T>::getId())",<< "unimplemented virtual function for child"); } ;
+      virtual CGenericAlgorithmTransformation* createAlgorithm(bool isSource,
+                                                               CGrid* gridDst, CGrid* gridSrc,
+                                                               int elementPositionInGrid,
+                                                               std::map<int, int>& elementPositionInGridSrc2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridSrc2DomainPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2ScalarPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2AxisPosition,
+                                                               std::map<int, int>& elementPositionInGridDst2DomainPosition) =0 ;
+
       /// Destructeur ///
     public:
